//
//  ClooseClassViewController.m
//  SelectDemo
//
//  Created by 邓龙 on 8/27/16.
//  Copyright © 2016 denglong. All rights reserved.
//

#import "ClooseClassViewController.h"

#import "HeaderView.h"
#import "BottomView.h"
#import "ChooseViewCell.h"

#define SCREEN [UIScreen mainScreen].bounds.size
static NSString * const ReuseIdentifierHeader = @"header";
static NSString * const ReuseIdentifierFooter = @"footer";
static NSString * const ReuseIdentifierCell = @"dcell";

@interface ClooseClassViewController ()<UITableViewDelegate, UITableViewDataSource>

@property (nonatomic, strong) UITableView         *chooseTable;
@property (nonatomic, strong) BottomView          *bottomView;

@property (nonatomic, strong) NSMutableDictionary *dataDic;
@property (nonatomic, strong) NSArray             *dataArray;

@property (nonatomic, strong) NSMutableArray      *expendArray;//记录打开的分组
@property (nonatomic, strong) NSMutableArray      *selectArray;//记录选择的所有选项
@property (nonatomic, assign) NSInteger           allListCount;//所有数据个数

@end

@implementation ClooseClassViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.title = @"有分类选择";
    self.view.backgroundColor = [UIColor whiteColor];
    
    [self createTableViewAction];
    [self createBottomViewAction];
    [self getDataRequestAction];
}

#pragma mark - get data request
- (void)getDataRequestAction {
    
    NSString *path  = [[NSBundle mainBundle] pathForResource:@"role" ofType:@"plist"];
    NSMutableArray *wai = [[NSMutableArray alloc] initWithContentsOfFile:path];
    for (int i = 0; i < wai.count; i ++)
    {
        NSArray *list = [wai[i] objectForKey:@"list"];
        NSMutableArray *array = [NSMutableArray arrayWithCapacity:0];
        for (int j = 0; j < list.count; j ++) {
            [array addObject:[list objectAtIndex:j]];
            
        }
        [self.dataDic setObject:array forKey:[wai[i] objectForKey:@"name"]];
    }
    self.dataArray = [self.dataDic allKeys];
    
    NSMutableArray *allList = [NSMutableArray array];
    for (NSString *key in self.dataArray) {
        
        NSArray *arrays = self.dataDic[key];
        [allList addObjectsFromArray:arrays];
    }
    self.allListCount = allList.count;
}

#pragma mark = create tableView
- (void)createTableViewAction {
    
    self.chooseTable = [[UITableView alloc] initWithFrame:CGRectZero style:UITableViewStylePlain];
    self.chooseTable.frame = CGRectMake(0, 0, SCREEN.width, SCREEN.height - 50);
    self.chooseTable.backgroundColor = self.view.backgroundColor;
    self.chooseTable.delegate = self;
    self.chooseTable.dataSource = self;
    [self.view addSubview:self.chooseTable];
    
    self.chooseTable.tableFooterView = [UIView new];
    [self.chooseTable registerNib:[UINib nibWithNibName:NSStringFromClass([HeaderView class]) bundle:nil] forHeaderFooterViewReuseIdentifier:ReuseIdentifierHeader];
    [self.chooseTable registerNib:[UINib nibWithNibName:NSStringFromClass([BottomView class]) bundle:nil] forHeaderFooterViewReuseIdentifier:ReuseIdentifierFooter];
    [self.chooseTable registerNib:[UINib nibWithNibName:@"ChooseViewCell" bundle:nil] forCellReuseIdentifier:ReuseIdentifierCell];
    
    [self.chooseTable setTableFooterView:[[UIView alloc] initWithFrame:CGRectZero]];
}

#pragma mark - create bottom view
- (void)createBottomViewAction {
    
    self.bottomView = [self.chooseTable dequeueReusableHeaderFooterViewWithIdentifier:ReuseIdentifierFooter];
    self.bottomView.frame = CGRectMake(0, SCREEN.height - 50, SCREEN.width, 50);
    self.bottomView.contentView.backgroundColor = [UIColor lightGrayColor];
    self.bottomView.nameLabel.text = @"全选";
    [self.bottomView.selectButton addTarget:self action:@selector(chooseAllAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:self.bottomView];
}

#pragma mark - Table view data source
#pragma mark - Table view data source
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableVie
{
    return self.dataArray.count;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    NSString *key = self.dataArray[section];
    NSArray *array = self.dataDic[key];
    
    if ([self.expendArray containsObject:key]) {
        return array.count;
    }else {
        return 0;
    }
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    return 60;
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section {
    return 60;
}

-(CGFloat)tableView:(UITableView *)tableView heightForFooterInSection:(NSInteger)section
{
    return 0;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section {
    NSString *key = self.dataArray[section];
    NSArray *array = self.dataDic[key];
    HeaderView *view = [tableView dequeueReusableHeaderFooterViewWithIdentifier:ReuseIdentifierHeader];
    view.nameLabel.text = key;
    view.selectButton.tag = section;
    
    UILabel *lab = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, 0.3)];
    lab.backgroundColor = [UIColor blackColor];
    lab.alpha = 0.2;
    [view addSubview:lab];
    
    BOOL selectAll = YES;
    for (id object in array) {
        if (![self.selectArray containsObject:object]) {
            selectAll = NO;
        }
    }
    view.selectButton.selected = selectAll;
    [view.selectButton addTarget:self action:@selector(headerButtonOnClick:) forControlEvents:UIControlEventTouchUpInside];
    
    [view.tap addTarget:self action:@selector(headerTap:)];
    
    if ([self.expendArray containsObject:key]) {
        view.jiantouInageView.transform = CGAffineTransformMakeRotation(M_PI_2);
    }else {
        view.jiantouInageView.transform = CGAffineTransformIdentity;
    }
    
    [self isAllSelectedAction];
    
    return view;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    NSString *key = self.dataArray[indexPath.section];
    NSArray *array = self.dataDic[key];
    NSString *name = array[indexPath.row];
    
    ChooseViewCell *cell = [tableView dequeueReusableCellWithIdentifier:ReuseIdentifierCell forIndexPath:indexPath];
    
    if ([self.selectArray containsObject:name]) {
        cell.selectImageVIew.selected = YES;
    }else {
        cell.selectImageVIew.selected = NO;
    }
    
    cell.nameLabel.text = name;
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
    NSString *key = self.dataArray[indexPath.section];
    NSArray *array = self.dataDic[key];
    NSString *name = array[indexPath.row];
    
    if ([self.selectArray containsObject:name]) {
        [self.selectArray removeObject:name];
    }else {
        [self.selectArray addObject:name];
    }
    
    [self.chooseTable reloadSections:[NSIndexSet indexSetWithIndex:indexPath.section] withRowAnimation:UITableViewRowAnimationNone];
}


#pragma mark - private methods
#pragma mark - select all
- (void)isAllSelectedAction {
    
    if (self.selectArray.count == self.allListCount) {
        
        self.bottomView.selectButton.selected = YES;
    }
    else
    {
        self.bottomView.selectButton.selected = NO;
    }
}

#pragma mark - select one class
- (void)headerButtonOnClick:(UIButton *)button {
    NSString *key = self.dataArray[button.tag];
    NSArray *array = self.dataDic[key];
    
    if (button.selected) {
        [self.selectArray removeObjectsInArray:array];
    }else {
        [self.selectArray addObjectsFromArray:array];
    }
    
    [self isAllSelectedAction];
    
    button.selected = !button.selected;
    
    [self.chooseTable reloadSections:[NSIndexSet indexSetWithIndex:button.tag] withRowAnimation:UITableViewRowAnimationNone];
}

#pragma mark - class tap action
- (void)headerTap:(UITapGestureRecognizer *)tap {
    HeaderView *view = (HeaderView *)tap.view;
    NSString *key = view.nameLabel.text;
    NSInteger index = [self.dataArray indexOfObject:key];
    
    if ([self.expendArray containsObject:key]) {
        [self.expendArray removeObject:key];
        [UIView animateWithDuration:0.1 animations:^{
            view.jiantouInageView.transform = CGAffineTransformIdentity;
        }];
    }else {
        [self.expendArray addObject:key];
        [UIView animateWithDuration:0.1 animations:^{
            view.jiantouInageView.transform = CGAffineTransformMakeRotation(M_PI_2);
        }];
    }
    
    [self.chooseTable reloadSections:[NSIndexSet indexSetWithIndex:index] withRowAnimation:UITableViewRowAnimationNone];
}

#pragma mark - select all

- (void)chooseAllAction:(UIButton *)sender {
    
    for (NSString *key in self.dataArray) {
        
        NSArray *array = self.dataDic[key];
        
        if (self.bottomView.selectButton.selected) {
            [self.selectArray removeObjectsInArray:array];
        }else {
            [self.selectArray addObjectsFromArray:array];
        }
    }
    
    self.bottomView.selectButton.selected = !self.bottomView.selectButton.isSelected;
    
    [self.chooseTable reloadData];
}


#pragma mark - getters

- (NSMutableDictionary *)dataDic {
    if (!_dataDic) {
        _dataDic = [NSMutableDictionary dictionaryWithCapacity:0];
    }
    return _dataDic;
}

- (NSMutableArray *)expendArray {
    if (!_expendArray) {
        _expendArray = [NSMutableArray arrayWithCapacity:0];
    }
    return _expendArray;
}

- (NSMutableArray *)selectArray {
    if (!_selectArray) {
        _selectArray = [NSMutableArray arrayWithCapacity:0];
    }
    return _selectArray;
}

@end
